#include "CRS.h"

#include<vector>
#include<iostream>

unsigned long int randuli( const unsigned long int m ) {
	return static_cast< unsigned long int >(  (static_cast< double >( rand() ) / static_cast< double >( RAND_MAX ) ) * static_cast< double >( m ) );
}

int main() {
	unsigned long int m = 500;
	unsigned long int n = 750;
	unsigned long int nnz = 750;
	double zero = 0.0;

	std::vector< Triplet< double > > naive;

	srand( 543213 );
	for( unsigned long int i=0; i<nnz; i++ ) {
		const unsigned long int _i = randuli( m );
		const unsigned long int _j = randuli( n );
		naive.push_back( Triplet< double >( i, i, 1.0 ) );
		//naive.push_back( Triplet< double >( _i == m ? m-1 : _i , _j == n ? n-1 : _j, 1.0 ) );
	}

	CRS< double > test( naive, zero );

	double* x = new double[ n ];
	for( unsigned long int i=0; i<n; i++ )
		x[i]=1.0;
	double* z = test.zax( x );
	std::cout << "[";
	for( unsigned long int i=0; i<( m-1 ); i++ )
		std::cout << z[ i ] << ",";
	std::cout << z[ m-1 ] << "]" << std::endl;
	delete [] z;
	delete [] x;
}

